Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 559798 - app-emulation/vmware-workstation-12 version bump
Summary: app-emulation/vmware-workstation-12 version bump
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal enhancement with 2 votes (vote)
Assignee: Gentoo VMWare Bug Squashers [disabled]
URL:
Whiteboard:
Keywords: EBUILD, PATCH
Depends on:
Blocks:
 
Reported: 2015-09-06 17:12 UTC by Billy DeVincentis
Modified: 2016-03-20 18:06 UTC (History)
11 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
vmware-bundle.eclass.patch (vmware-bundle.eclass.patch,1.38 KB, patch)
2015-09-19 20:04 UTC, Fabio Rossi
Details | Diff
vmware-workstation-12.0.0.2985596.ebuild (vmware-workstation-12.0.0.2985596.ebuild,13.88 KB, text/plain)
2015-09-19 20:04 UTC, Fabio Rossi
Details
vmware-bundle.eclass.patch (vmware-bundle.eclass.patch,1.10 KB, patch)
2015-09-20 14:48 UTC, Alex Xu (Hello71)
Details | Diff
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch (vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch,644 bytes, patch)
2015-09-20 14:49 UTC, Alex Xu (Hello71)
Details | Diff
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch (vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch,2.42 KB, patch)
2015-09-20 17:28 UTC, Alex Xu (Hello71)
Details | Diff
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch (vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch,2.71 KB, patch)
2015-09-20 17:37 UTC, Alex Xu (Hello71)
Details | Diff
vmware-workstation-12.0.0.2985596.ebuild (vmware-workstation-12.0.0.2985596.ebuild,13.75 KB, text/plain)
2015-09-24 02:08 UTC, Billy DeVincentis
Details
vmware-modules-308.0.ebuild (vmware-modules-308.0.ebuild,3.70 KB, text/plain)
2015-09-24 02:09 UTC, Billy DeVincentis
Details
vmware-tools-10.0.0.2977863.ebuild (vmware-tools-10.0.0.2977863.ebuild,1.34 KB, text/plain)
2015-09-24 02:12 UTC, Billy DeVincentis
Details
vmware-workstation-12.0.0.2985596.ebuild (vmware-workstation-12.0.0.2985596.ebuild,13.87 KB, text/plain)
2015-09-30 00:17 UTC, Billy DeVincentis
Details
Patch vmmon for kernel-4.3.0 (vmmon-413.patch,1.36 KB, patch)
2015-11-03 01:55 UTC, Harris Landgarten
Details | Diff
0001-vmware-bundle.eclass-skip-empty-files.patch (0001-vmware-bundle.eclass-skip-empty-files.patch,1.07 KB, patch)
2015-12-20 20:02 UTC, Alex Xu (Hello71)
Details | Diff
0002-app-emulation-vmware-Update.patch (0002-app-emulation-vmware-Update.patch,60.23 KB, patch)
2015-12-20 20:08 UTC, Alex Xu (Hello71)
Details | Diff
308-4.03-00-vmmonInt.patch (308-4.03-00-vmmonInt.patch,975 bytes, patch)
2015-12-25 22:32 UTC, John Doe
Details | Diff
vmware-modules-308.1.0.ebuild.patch (vmware-modules-308.1.0.ebuild.patch,469 bytes, patch)
2016-01-17 12:57 UTC, Fabio Rossi
Details | Diff
screenshot of small fonts (Screenshot (8).png,261.74 KB, image/png)
2016-03-17 01:01 UTC, Billy DeVincentis
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Billy DeVincentis 2015-09-06 17:12:10 UTC
New version out, unfortunately rename of ebuild doesn't work. Would be nice to get this worked out.
Comment 1 David Carlos Manuelda 2015-09-07 08:48:51 UTC
Specially because kernel-4.2 brings problems into compiling vmware-modules again (at least for 11 version present in vmware overlay, that according google, are solved in version 12)
Comment 2 Harris Landgarten 2015-09-09 13:24:31 UTC
I posted patches to vmware-modules for kernel-4.2 in bug # 531682

There are 2 patches and if you put theme in /etc/portage/patches/app-emulation/vmware-modules/

and use kernel based vsock and vmci you will have no problems.
Comment 3 Billy DeVincentis 2015-09-10 12:31:35 UTC
Rename of ebuild didn't work, can you post the new ebuild?
Comment 4 Andreas K. Hüttel gentoo-dev 2015-09-19 19:32:35 UTC
(In reply to Billy DeVincentis from comment #0)
> New version out, unfortunately rename of ebuild doesn't work. Would be nice
> to get this worked out.

Sadly right now I'm as stumped as you are. I've asked the original eclass author (who wrote the unpackging code) for help, let's hope he responds...
Comment 5 Fabio Rossi 2015-09-19 20:03:18 UTC
Here is a version of the ebuild working, it depends on vmware-modules-308 which can be put in another bug report (because it's in common with vmware-player).

Anyway, first of all it's needed a patch for vmware-bundle.eclass (also for vmware-player-12) because there are files with size 0 that create problems.

Then the bundle doesn't seem to include anymore man pages and xdg files, so I removed those lines from src_install()
Comment 6 Fabio Rossi 2015-09-19 20:04:00 UTC
Created attachment 412298 [details, diff]
vmware-bundle.eclass.patch
Comment 7 Fabio Rossi 2015-09-19 20:04:29 UTC
Created attachment 412300 [details]
vmware-workstation-12.0.0.2985596.ebuild
Comment 8 Alex Xu (Hello71) 2015-09-20 14:48:57 UTC
Created attachment 412336 [details, diff]
vmware-bundle.eclass.patch

remove $Id$ chunk from git transition
Comment 9 Alex Xu (Hello71) 2015-09-20 14:49:34 UTC
Created attachment 412338 [details, diff]
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch

convert to patch format for easier reading
Comment 10 Billy DeVincentis 2015-09-20 15:24:37 UTC
vmware-bundle_extract-bundle-component "${bundle}" vmware-vix-lib-Workstation1100andvSphere600 vmware-vix


Are we sure these numbers are correct in the ebuild? I thought it should be workstation1200...
Comment 11 Alex Xu (Hello71) 2015-09-20 17:28:40 UTC
Created attachment 412348 [details, diff]
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch

remove cups USE flag of dubious use, fix deps, fix vix
Comment 12 Alex Xu (Hello71) 2015-09-20 17:37:47 UTC
Created attachment 412350 [details, diff]
vmware-workstation-11.1.2.2780323-r1-12.0.0.2985596.ebuild.patch

oops
Comment 13 Billy DeVincentis 2015-09-21 11:48:57 UTC
Small problem I believe Alex,

Workstation1100andvSphere600

You left out "andvSphere600" but I'm not sure what the actual version number of vsphere should be. I believe you need to actually extract the files from the installer to see.
Comment 14 Alex Xu (Hello71) 2015-09-21 20:18:32 UTC
(In reply to Billy DeVincentis from comment #13)
> Small problem I believe Alex,
> 
> Workstation1100andvSphere600
> 
> You left out "andvSphere600"

yes

> but I'm not sure what the actual version number
> of vsphere should be.

none

> I believe you need to actually extract the files from
> the installer to see.

yes
Comment 15 Billy DeVincentis 2015-09-22 02:02:14 UTC
So vsphere is no longer a part of this?
Comment 16 Billy DeVincentis 2015-09-23 21:27:58 UTC
Just tried this

chmod: cannot access ‘/var/tmp/portage/app-emulation/vmware-workstation-12.0.0.2985596/image//opt/vmware/lib/vmware/bin/vmware-wssc-adminTool’: No such file or directory
 * ERROR: app-emulation/vmware-workstation-12.0.0.2985596::miscellaneous failed (install phase):


Maybe this part is no longer a part of the program?
Comment 17 Alex Xu (Hello71) 2015-09-23 23:44:07 UTC
(In reply to Billy DeVincentis from comment #16)
> Just tried this
> 
> chmod: cannot access
> ‘/var/tmp/portage/app-emulation/vmware-workstation-12.0.0.2985596/image//opt/
> vmware/lib/vmware/bin/vmware-wssc-adminTool’: No such file or directory
>  * ERROR: app-emulation/vmware-workstation-12.0.0.2985596::miscellaneous
> failed (install phase):
> 
> 
> Maybe this part is no longer a part of the program?

this doesn't make sense; it doesn't seem like the built-in launcher can work, given that it references vmware-wssc-adminTool which doesn't seem to be installed.

I guess USE=-server for now until the next release.
Comment 18 Billy DeVincentis 2015-09-24 02:07:00 UTC
okay,
  I got this working tonight. Just to be helpful I am posting the actual ebuilds that I used to get it working
Comment 19 Billy DeVincentis 2015-09-24 02:08:17 UTC
Created attachment 412688 [details]
vmware-workstation-12.0.0.2985596.ebuild

patched ebuild
Comment 20 Billy DeVincentis 2015-09-24 02:09:28 UTC
Created attachment 412690 [details]
vmware-modules-308.0.ebuild

Only the 4.2 linux inode patch was used as per previous comment
Comment 21 Billy DeVincentis 2015-09-24 02:11:40 UTC
https://bugs.gentoo.org/show_bug.cgi?id=531682

patch is here
Comment 22 Billy DeVincentis 2015-09-24 02:12:15 UTC
Created attachment 412692 [details]
vmware-tools-10.0.0.2977863.ebuild
Comment 23 Billy DeVincentis 2015-09-24 02:13:47 UTC
I didn't have the time but hopefully someone can take this and create new bugs for the module and tool ebuilds. Also if anyone can figure out why the server use flag cannot be used, that would be great
Thanks
Comment 24 Billy DeVincentis 2015-09-24 03:15:43 UTC
I'm afraid there is a problem. If I close vmware-workstation while a vm is running, when I reopen the windows the vm is still running but I cannot access it, it shows a black window as if it is powered down.
Comment 25 Alex Xu (Hello71) 2015-09-24 22:20:31 UTC
(In reply to Billy DeVincentis from comment #24)
> I'm afraid there is a problem. If I close vmware-workstation while a vm is
> running, when I reopen the windows the vm is still running but I cannot
> access it, it shows a black window as if it is powered down.

if you have USE=-vix or somesuch I think you may need to manually disable the "keep VM alive on close" option in Workstation.
Comment 26 Billy DeVincentis 2015-09-25 12:35:52 UTC
I definitely use the vix use flag. I think it may have had something to do with disabling the server flag. I have "keep vms running after workstation closes" checked. The running VM doesn't actually get shut down when I close workstation. It keeps running but I lose permission to access it when I reopen workstation.

Can you explain with more detail what was happening causing use "server" to make the emerge fail? I think fixing that may solve the problem.
Comment 27 Fabio Rossi 2015-09-28 08:06:27 UTC
Bill, I have a question. I'm not using workstation but the player, do you have the icons on the right of the bottom bar in the virtual machine window? I'm referring to the icons with the network and disk activity, usb devices, etc
Comment 28 Manfred Knick 2015-09-28 11:59:31 UTC
@ Billy DeVincentis :

Can we get your new attachments (ebuilds) into vmware overlay, please?

Thanks a lot in advance.
Comment 29 Billy DeVincentis 2015-09-28 12:24:29 UTC
Fabio,
 To the best of my recollection it did have the icons. I am now remembering that at one time in the past I was having the very same problem when I emerged this and did not use server use flag, in order to have vms running and be able to open and close workstation and not lose ownership of the running vm, it has to have the server use flag. I don't know what is the story with the missing file, possibly a problem with the eclass file not unbundling this correctly?
Comment 30 Billy DeVincentis 2015-09-28 12:25:46 UTC
Manfred, it's not working properly yet. When it is I will post zip files with all the necessary folders and if someone wishes to put it into an overlay, that is fine by me.
Comment 31 Fabio Rossi 2015-09-28 12:35:47 UTC
@ Billy:
> possibly a problem with the eclass file not unbundling this correctly?
The changes to the eclass I made were only related to skipping files with 0 bytes size (compressed version) which gave errors during unpacking

@ Manfred:
A few days ago I have already made a pull request on github (https://github.com/gentoo/vmware/pull/15) to the gentoo developer for the latest changes to have support for version 12 of player, workstation and modules. I'll soon integrate the latest changes from Billy and also the tools. Please try directly from my github overlay to see if everything works also for you.
Comment 32 Billy DeVincentis 2015-09-29 11:50:38 UTC
https://github.com/gentoo/vmware/tree/master/app-emulation
I don't see 12 ebuilds
Comment 33 Billy DeVincentis 2015-09-29 11:52:18 UTC
where is your overlay?
Comment 34 Fabio Rossi 2015-09-29 12:11:43 UTC
(In reply to Billy DeVincentis from comment #33)
> where is your overlay?

https://github.com/efferre79/vmware

right now I don't have included yet your changes to the workstation ebuild, how did you find the missing deps?
Comment 35 Billy DeVincentis 2015-09-29 23:57:31 UTC
Just a couple of things to fix,
1- correct version of workstation from 1100 to 1200 in vmware-workstation ebuild
2- use my ebuild for tools, yours doesn't download files correctly

Other than that it seems to have emerged correctly

I will report back after restarting
Comment 36 Billy DeVincentis 2015-09-30 00:15:52 UTC
Okay
1 small problem after restarting, vix wasn't working

here is the correct line for the workstation ebuild

vmware-bundle_extract-bundle-component "${bundle}" vmware-vix-lib-Workstation1200 vmware-vix
Comment 37 Billy DeVincentis 2015-09-30 00:17:23 UTC
Created attachment 413330 [details]
vmware-workstation-12.0.0.2985596.ebuild

here is the working ebuild
Hooray we have workstation 12 working!!!!!
Please fix the is your overlay
Thanks
Comment 38 Billy DeVincentis 2015-09-30 00:28:03 UTC
Just wanted to point out this
in package.use

app-emulation/vmware-modules -vmci -vsock

Have to build this into kernel to keep this simple

Also, I have this file in 
/etc/modprobe.d/vmware.conf

# Support for vmware in kernel modules
alias vmci              vmw_vmci
alias vsock             vmw_vsock_vmci_transport


This prevents problems with vmci module naming and failure of the vmci service to start
Of course should you change this one day to use modules from the ebuild, you should remove the file
Comment 39 Fabio Rossi 2015-09-30 10:18:37 UTC
Billy, thanks for the feedback, I have also fixed the ssl symlinks. Please have a check :-) Fixed also the tools BASE_URI, damn upstream!

Moreover I have also introduced a newer version for the vmware-modules (308.0-r1) to automatically create the modprobe file. It seems to me that the vsock module, when built in the kernel, needs also the vmci module built always in the kernel (if CONFIG_VMWARE_VMCI option is not enabled then CONFIG_VMWARE_VMCI_VSOCKETS is not available). For this reason I have introduced a restriction on the USE flags in the ebuild. 

I don't build the vmware modules in the kernel, if you do then I'd ask to test them building the package with USE="-vmci" and USE="-vmci -vsock". I'm not sure they will work because I get this warning during :

/var/tmp/portage/app-emulation/vmware-modules-308.0-r1/work/vmmon-only/linux/driver.c: In function ‘LinuxDriver_Ioctl’:
/var/tmp/portage/app-emulation/vmware-modules-308.0-r1/work/vmmon-only/linux/driver.c:1985:1: warning: the frame size of 1124 bytes is larger than 1024 bytes [-Wframe-larger-than=]
 }
Comment 40 Billy DeVincentis 2015-09-30 11:55:11 UTC
Are all modules now building with your new vmware-modules ebuild? If so I may try removing those modules on my next kernel build and I will try the r1 ebuild you mention. I never used to use the in kernel modules but module building became problematic in vmware 11.
Comment 41 Fabio Rossi 2015-09-30 12:22:56 UTC
(In reply to Billy DeVincentis from comment #40)
> Are all modules now building with your new vmware-modules ebuild? If so I
> may try removing those modules on my next kernel build and I will try the r1
> ebuild you mention. I never used to use the in kernel modules but module
> building became problematic in vmware 11.

On my system all 5 modules are compiling fine, I have used them with the player. I have "+vmci +vsock" so I was wondering if vmware-modules still works with "-vmci" or "-vmci -vsock"
Comment 42 Billy DeVincentis 2015-09-30 18:48:51 UTC
app-emulation/vmware-modules -vmci -vsock
is in my package.use, it definitely works and frankly i think it's better because these modules become difficult to compile once new kernel versions are released.
Comment 43 Fabio Rossi 2015-09-30 19:13:14 UTC
(In reply to Billy DeVincentis from comment #42)
> app-emulation/vmware-modules -vmci -vsock
> is in my package.use, it definitely works and 

good!

> frankly i think it's better
> because these modules become difficult to compile once new kernel versions
> are released.

this is a matter of patching, you know that Gentoo is world of choices :-)
Comment 44 Fabio Rossi 2015-09-30 20:32:16 UTC
(In reply to Fabio Rossi from comment #27)
> Bill, I have a question. I'm not using workstation but the player, do you
> have the icons on the right of the bottom bar in the virtual machine window?
> I'm referring to the icons with the network and disk activity, usb devices,
> etc

Never mind, problem not visible any more (I don't know the reason)
Comment 45 Fabio Rossi 2015-10-01 09:11:24 UTC
(In reply to Billy DeVincentis from comment #38)
> Just wanted to point out this
> in package.use
> 
> app-emulation/vmware-modules -vmci -vsock
> 
> Have to build this into kernel to keep this simple
> 
> Also, I have this file in 
> /etc/modprobe.d/vmware.conf
> 
> # Support for vmware in kernel modules
> alias vmci              vmw_vmci
> alias vsock             vmw_vsock_vmci_transport
> 
> 
> This prevents problems with vmci module naming and failure of the vmci
> service to start
> Of course should you change this one day to use modules from the ebuild, you
> should remove the file

The current vmware init file already manages the different naming of vmci module, why someone should introduce the aliases?
Comment 46 Billy DeVincentis 2015-10-01 11:46:29 UTC
for openrc maybe, not for systemd
Comment 47 Manfred Knick 2015-10-06 11:30:32 UTC
RDEPEND="...
	=dev-libs/libgcrypt-1.5*

Please note

Bug 562384 :
  [overlay] 
  vmware-workstation-11.1.2.2780323-r[1..3].ebuild : 
  ">=dev-libs/libgcrypt-1.5.0:0/11" conflicts
Comment 48 Fabio Rossi 2015-10-06 13:22:29 UTC
(In reply to Manfred Knick from comment #47)
> RDEPEND="...
> 	=dev-libs/libgcrypt-1.5*
> 
> Please note
> 
> Bug 562384 :
>   [overlay] 
>   vmware-workstation-11.1.2.2780323-r[1..3].ebuild : 
>   ">=dev-libs/libgcrypt-1.5.0:0/11" conflicts

That is the version bundled in the vmware package, probably it's conservative. Currently vmware comes with lots of bundled libs which are used instead of the system ones. The dependencies, as written in the ebuild, are probably wrong or useless so I didn't care about that part of the ebuild in my overlay. The reason is that Andreas is working on the ebuild (see the 11.*-r2 version in his overlay) to fix the mess, so... work in progress :-)
Comment 49 Harris Landgarten 2015-11-03 01:55:47 UTC
Created attachment 415968 [details, diff]
Patch vmmon for kernel-4.3.0

This is patch so vmmon builds and works with 4.3.0 kernel. I have tested it was vmware-workstation-11 but it should would with 12.0 too. I believe 12.0.1 does not need it but this should be confirmed.
Comment 50 Fabio Rossi 2015-11-03 09:08:09 UTC
(In reply to Harris Landgarten from comment #49)
> Created attachment 415968 [details, diff] [details, diff]
> Patch vmmon for kernel-4.3.0
> 
> This is patch so vmmon builds and works with 4.3.0 kernel. I have tested it
> was vmware-workstation-11 but it should would with 12.0 too. I believe
> 12.0.1 does not need it but this should be confirmed.

Thanks for testing the patch from my overlay, anyway I have updated it so that modules 308.0 and 308.1 are both patched correctly against kernel 4.3.
Comment 51 Billy DeVincentis 2015-12-20 18:29:04 UTC
vmware-workstation-12.1.0.3272444.ebuild should be the latest version but I am having trouble with the naming scheme for the vmware-modules. The previous version was using 308.1. What should the name be for 12.1 workstation?
Comment 52 Alex Xu (Hello71) 2015-12-20 20:02:15 UTC
Created attachment 419936 [details, diff]
0001-vmware-bundle.eclass-skip-empty-files.patch
Comment 53 Alex Xu (Hello71) 2015-12-20 20:08:30 UTC
Created attachment 419938 [details, diff]
0002-app-emulation-vmware-Update.patch
Comment 54 Alex Xu (Hello71) 2015-12-20 20:10:09 UTC
tested working on kernel 4.4.0-rc5+ with USE=-bundled-libs. if USE=bundled-libs and on ~amd64 then there is a symbol error.
Comment 55 Harris Landgarten 2015-12-20 21:58:38 UTC
for 12.1 I used 309.0 you have to rename the 308 patches.
Comment 56 Billy DeVincentis 2015-12-21 00:39:48 UTC
Hi Harris,
  I renamed the ebuilds, copied the 308 patches for the modules and successfully emerge 12.1 ws and 309 modules but I have a problem using kde. The fonts no longer work for workstation. The fonts are really tiny for the ws gui. If I log into Gnome, fonts appear fine. Did you notice this? WS 12.0 does not exhibit this issue
Comment 57 Harris Landgarten 2015-12-21 02:13:59 UTC
I use gnome-3.18 I don't run kde. Odd problem.
Comment 58 Billy DeVincentis 2015-12-21 02:17:45 UTC
Hi Alex,
  Do you have an overlay with all these ebuilds?
Comment 59 Fabio Rossi 2015-12-21 09:53:40 UTC
(In reply to Harris Landgarten from comment #55)
> for 12.1 I used 309.0 you have to rename the 308 patches.

If you look in vmmon-only/include/iocontrols.h you can find

    #define VMMON_VERSION           (308 << 16 | 0)

so the version of vmware modules embedded in the latest release 12.1.0.3272444  is still 308. I have already opened an issue in https://github.com/gentoo/vmware/issues/18 to understand which is the best way to proceed. My solution is to change the naming scheme from 308.x to 308.x.y. Later today I'll push the local changes to my github repository
Comment 60 Harris Landgarten 2015-12-21 18:18:26 UTC
thanks. Is there a new build# for vmware-tools? I couldn't find it on the net.
Comment 61 Fabio Rossi 2015-12-21 22:37:25 UTC
I have updated the repository, there is also the new version of vmware-tools 10.0.5.3228253. I haven't merged yet the latest changes regarding the new bundled-libs useflag.

I'm using only vmware-player so please test vmware-workstation.
Comment 62 Billy DeVincentis 2015-12-22 13:21:49 UTC
Just wanted to confirm that ebuilds as per Fabios repository all work as expected. Unfortunately my problem still exists with fonts in kde. What I have noticed is that on Fedora 23 with newer kde Plasma, fonts work as expected.
Comment 63 Andrew Saunders 2015-12-24 09:21:10 UTC
I tried compiling from the overlay and vmware-modules fails with this error

In file included from /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/linux/hostif.c:97:0:
/tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/linux/hostif.c: In function ‘HostIF_CallOnEachCPU’:
/tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/linux/vmmonInt.h:34:50: error: too many arguments to function ‘smp_call_function’
 #define compat_smp_call_function(fn, info, wait) smp_call_function(fn, info, 1, wait)

using kernel 4.3.3 , renaming to 309 gives the same error. workstation and tools compiled fine.
Comment 64 Fabio Rossi 2015-12-24 11:50:20 UTC
(In reply to Andrew Saunders from comment #63)
> I tried compiling from the overlay and vmware-modules fails with this error
> 
> In file included from
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/hostif.c:97:0:
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/hostif.c: In function ‘HostIF_CallOnEachCPU’:
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/vmmonInt.h:34:50: error: too many arguments to function
> ‘smp_call_function’
>  #define compat_smp_call_function(fn, info, wait) smp_call_function(fn,
> info, 1, wait)
> 
> using kernel 4.3.3 , renaming to 309 gives the same error. workstation and
> tools compiled fine.

I cannot reproduce this error with gentoo-sources-4.3.3, which kernel are you using? Are you sure /usr/src/linux is pointing to a 4.x kernel? For some reason VMW_HAVE_SMP_CALL_3ARG is not defined which is bad, this should happen with kernels < 2.6.27
Comment 65 Andrew Saunders 2015-12-25 06:02:42 UTC
(In reply to Fabio Rossi from comment #64)
> I cannot reproduce this error with gentoo-sources-4.3.3, which kernel are
> you using? Are you sure /usr/src/linux is pointing to a 4.x kernel? For some
> reason VMW_HAVE_SMP_CALL_3ARG is not defined which is bad, this should
> happen with kernels < 2.6.27

/usr/src/linux -> linux-4.3.3

$ uname -a
Linux hedgehog 4.3.3 #1 SMP PREEMPT Tue Dec 15 14:47:15 AST 2015 x86_64 AMD FX(tm)-8350 Eight-Core Processor AuthenticAMD GNU/Linux

strange. I compile my own kernel and don't use genkernel though.
Comment 66 John Doe 2015-12-25 22:30:57 UTC
(In reply to Andrew Saunders from comment #63)
> I tried compiling from the overlay and vmware-modules fails with this error
> 
> In file included from
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/hostif.c:97:0:
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/hostif.c: In function ‘HostIF_CallOnEachCPU’:
> /tmp/portage/portage/app-emulation/vmware-modules-308.1.0/work/vmmon-only/
> linux/vmmonInt.h:34:50: error: too many arguments to function
> ‘smp_call_function’
>  #define compat_smp_call_function(fn, info, wait) smp_call_function(fn,
> info, 1, wait)
> 
> using kernel 4.3.3 , renaming to 309 gives the same error. workstation and
> tools compiled fine.

Been there.

You need this patch (308-4.03-00-vmmonInt.patch) and include the following line in the ebuild.

[code]
kernel_is ge 4 03 0 && epatch "${FILESDIR}/${PV_MAJOR}-4.03-00-vmmonInt.patch"
[/code]
Comment 67 John Doe 2015-12-25 22:32:24 UTC
Created attachment 420850 [details, diff]
308-4.03-00-vmmonInt.patch
Comment 68 Fabio Rossi 2015-12-26 19:52:09 UTC
(In reply to Andrew Saunders from comment #65)
> (In reply to Fabio Rossi from comment #64)
> > I cannot reproduce this error with gentoo-sources-4.3.3, which kernel are
> > you using? Are you sure /usr/src/linux is pointing to a 4.x kernel? For some
> > reason VMW_HAVE_SMP_CALL_3ARG is not defined which is bad, this should
> > happen with kernels < 2.6.27
> 
> /usr/src/linux -> linux-4.3.3
> 
> $ uname -a
> Linux hedgehog 4.3.3 #1 SMP PREEMPT Tue Dec 15 14:47:15 AST 2015 x86_64 AMD
> FX(tm)-8350 Eight-Core Processor AuthenticAMD GNU/Linux
> 
> strange. I compile my own kernel and don't use genkernel though.

which kernel are you using? can you post a .config?
Comment 69 Andrew Saunders 2015-12-27 05:37:16 UTC
(In reply to John Doe from comment #66)
> Been there.
> 
> You need this patch (308-4.03-00-vmmonInt.patch) and include the following
> line in the ebuild.
> 
> [code]
> kernel_is ge 4 03 0 && epatch
> "${FILESDIR}/${PV_MAJOR}-4.03-00-vmmonInt.patch"
> [/code]

Just lazily threw it in /patch and it compiled no problem.


(In reply to Fabio Rossi from comment #68)

> which kernel are you using? can you post a .config?

Just the vanilla with a handful of patches from here http://dev.gentoo.org/~mpagano/genpatches/trunk/4.3/

config - http://pastebin.com/YYCmNnnz

ignore that it says 4.3.1, my script just copies earlier configs for minor revs.
Comment 70 Fabio Rossi 2015-12-27 14:00:33 UTC
(In reply to Andrew Saunders from comment #69)

> Just the vanilla with a handful of patches from here
> http://dev.gentoo.org/~mpagano/genpatches/trunk/4.3/
> 
> config - http://pastebin.com/YYCmNnnz
> 
> ignore that it says 4.3.1, my script just copies earlier configs for minor
> revs.

BTW: Those are the patches included in gentoo-sources-4.3.3

Anyway I can compile successfully using the vanilla-4.3.3 source and the .config you posted using all the patches [1-4]* available in the link above (excluding 100?_linux-4.3.?.patch and 5010_enable-additional-cpu-optimizations-for-gcc-4.9.patch). I'm using gcc 4.8.5.

The 308-4.03-00-vmmonInt.patch is only a workaround, it'd be interesting to understand why VMW_HAVE_SMP_CALL_3ARG is not defined as it should be. This means that in your system vmmon-only/autoconf/smpcall.c is not compiled successfully. Can you change the ebuild removing the 308-4.03-00-vmmonInt.patch and using the following patch?

--- vmware-modules-308.1.0.ebuild        2015-12-08 21:08:51.490700810 +0100
+++ vmware-modules-308.1.0.ebuild.new 2015-12-27 14:38:30.006228692 +0100
@@ -27,6 +27,8 @@
 
 S=${WORKDIR}
 
+BUILD_PARAMS="V=1 SHELL='sh -x'"
+
 pkg_setup() {
        CONFIG_CHECK="~HIGH_RES_TIMERS"
        if kernel_is ge 2 6 37 && kernel_is lt 2 6 39; then

Then you can execute:

USE="-vsock -vmci" ebuild /path/to/your/app-emulation/vmware-modules/vmware-modules-308.1.0.ebuild clean install

and post the log file /var/tmp/portage/app-emulation/vmware-modules-308.1.0/temp/build.log.gz on pastebin
Comment 71 Fabio Rossi 2016-01-17 12:56:58 UTC
> Been there.
> 
> You need this patch (308-4.03-00-vmmonInt.patch) and include the following
> line in the ebuild.
> 
> [code]
> kernel_is ge 4 03 0 && epatch
> "${FILESDIR}/${PV_MAJOR}-4.03-00-vmmonInt.patch"
> [/code]

John, your patch is not the right way to go, probably you have some SSE related gcc options in your CFLAGS (are you using a 64 bit system, right?). Would you mind trying the new attached patch? It solves the problem for Andrew
Comment 72 Fabio Rossi 2016-01-17 12:57:56 UTC
Created attachment 423140 [details, diff]
vmware-modules-308.1.0.ebuild.patch
Comment 73 Fabio Rossi 2016-01-19 00:04:45 UTC
Please test latest 12.1.0.3272444-r1 version in my github repo with bundled-libs useflag enabled/disabled.
Comment 74 Harris Landgarten 2016-01-19 15:03:14 UTC
you should be calling for libgcrypt:11/11 

As it is now paludis is calling for 0/11 which would replace 0/20 and cause blockages.
Comment 75 Harris Landgarten 2016-01-19 16:09:18 UTC
Note the libgcrypt issue is paludis only. Reversing he order of the ||() fixes it
Comment 76 Fabio Rossi 2016-01-21 09:04:18 UTC
(In reply to Harris Landgarten from comment #74)
> you should be calling for libgcrypt:11/11 
> 
> As it is now paludis is calling for 0/11 which would replace 0/20 and cause
> blockages.

Actually vmware needs both libgcrypt.so.11 and libgcrypt.so.20, I have fixed the deps with latest commit
Comment 77 Billy DeVincentis 2016-03-09 13:29:25 UTC
After latest round of updates, workstation and player are not starting

billydv@Linux1 ~ $ /opt/vmware/bin/vmware
Loop on signal 11.
billydv@Linux1 ~ $ /opt/vmware/bin/vmplayer
Gtk-Message: Failed to load module "canberra-gtk-module": libcanberra-gtk-module.so: cannot open shared object file: No such file or directory
Loop on signal 11.
billydv@Linux1 ~ $


Anyone have any ideas?
Comment 78 Harris Landgarten 2016-03-09 14:30:29 UTC
try it with bundled_libs
Comment 79 Billy DeVincentis 2016-03-09 22:19:27 UTC
here is my package.use

app-emulation/vmware-workstation cups ovftool server vix vmware-tools bundled-libs
Comment 80 Billy DeVincentis 2016-03-09 22:27:13 UTC
use = -bundled-libs fixed problem

also fixed small font problem in kde
Comment 81 Fabio Rossi 2016-03-10 09:23:15 UTC
(In reply to Billy DeVincentis from comment #80)

> use = -bundled-libs fixed problem
> 
> also fixed small font problem in kde

Billy, did you use the latest version in my github repo? Only vmware-workstation is completed from bundled-libs point of view (even if there are some minor issues).
Comment 82 Alexander Bezrukov 2016-03-10 11:36:10 UTC
Fabio,

are you aware of the following issue with USE=-bundled-libs?

 ldd /opt/vmware/lib/vmware/libconf/lib/gtk-2.0/2.10.0/loaders/libpixbufloader-tiff.so
ldd: warning: you do not have execution permission for `/opt/vmware/lib/vmware/libconf/lib/gtk-2.0/2.10.0/loaders/libpixbufloader-tiff.so'
	linux-vdso.so.1 (0x00007ffeaa9f0000)
	libtiff.so.3 => not found    <--- !!!!!!!!
	libgdk_pixbuf-2.0.so.0 => /usr/lib64/libgdk_pixbuf-2.0.so.0 (0x00007faa79109000)
	libgio-2.0.so.0 => /usr/lib64/libgio-2.0.so.0 (0x00007faa78d8e000)
	libgobject-2.0.so.0 => /usr/lib64/libgobject-2.0.so.0 (0x00007faa78b3c000)
	libgmodule-2.0.so.0 => /usr/lib64/libgmodule-2.0.so.0 (0x00007faa78937000)
	libgthread-2.0.so.0 => /usr/lib64/libgthread-2.0.so.0 (0x00007faa78735000)
	librt.so.1 => /lib64/librt.so.1 (0x00007faa7852e000)
	libglib-2.0.so.0 => /usr/lib64/libglib-2.0.so.0 (0x00007faa781f7000)
	libm.so.6 => /lib64/libm.so.6 (0x00007faa77ef6000)
	libpthread.so.0 => /lib64/libpthread.so.0 (0x00007faa77cda000)
	libc.so.6 => /lib64/libc.so.6 (0x00007faa77941000)
	libz.so.1 => /lib64/libz.so.1 (0x00007faa7772b000)
	libresolv.so.2 => /lib64/libresolv.so.2 (0x00007faa77514000)
	libffi.so.6 => /usr/lib64/libffi.so.6 (0x00007faa7730b000)
	libdl.so.2 => /lib64/libdl.so.2 (0x00007faa77107000)
	/lib64/ld-linux-x86-64.so.2 (0x000056081733b000)
Comment 83 Fabio Rossi 2016-03-12 01:08:14 UTC
(In reply to Alexander Bezrukov from comment #82)
> Fabio,
> 
> are you aware of the following issue with USE=-bundled-libs?
 
Yes, I have updated the repository fixing the deps list and removing other bundled-libs. Please test it.
Comment 84 Alexander Bezrukov 2016-03-12 03:44:49 UTC
(In reply to Fabio Rossi from comment #83)
> (In reply to Alexander Bezrukov from comment #82)
> > Fabio,
> > 
> > are you aware of the following issue with USE=-bundled-libs?
>  
> Yes, I have updated the repository fixing the deps list and removing other
> bundled-libs. Please test it.

Yes, vmware now uses system gdk-pixbuf.

By the way, is it really necessary to pull pulseaudio? I will try to check this later, right now I have no physical access to a computer running gentoo.
Comment 85 Fabio Rossi 2016-03-12 09:23:35 UTC
(In reply to Alexander Bezrukov from comment #84)

> Yes, vmware now uses system gdk-pixbuf.
> 
> By the way, is it really necessary to pull pulseaudio? I will try to check
> this later, right now I have no physical access to a computer running gentoo.

The library is dynamically loaded by a few binaries in /opt/vmware/lib/vmware/bin/, e.g. vmware-vmx
Comment 86 Alexander Bezrukov 2016-03-14 01:13:25 UTC
(In reply to Fabio Rossi from comment #85)
> (In reply to Alexander Bezrukov from comment #84)
> > By the way, is it really necessary to pull pulseaudio? I will try to check
> > this later, right now I have no physical access to a computer running gentoo.
> 
> The library is dynamically loaded by a few binaries in
> /opt/vmware/lib/vmware/bin/, e.g. vmware-vmx

I just tried to run it without pulseaudio installed. It uses pure ALSA then. Sound works well at least in a Windows guest with vmware-tools installed. I believe, pulseaudio dependency may be safely removed.

I also noticed that vmware-vmx tries to bind dynamically to libhal.so.1 but feels equally happy without hal.

By the way, I found another minor issue. Entering serial number doesn't work when USE=-bundled-libs with the following error:

I125: HandleLicenseOutput(stdErr): /opt/vmware/lib/vmware/bin/vmware-gksu: symbol lookup error: /opt/vmware/lib/vmware/lib/libvmware-gksu.so/libvmware-gksu.so: undefined symbol: gksu_context_set_on_fork

Bundled libgksu works as expected.
Comment 87 Fabio Rossi 2016-03-14 21:34:48 UTC
> I just tried to run it without pulseaudio installed. It uses pure ALSA then.
> Sound works well at least in a Windows guest with vmware-tools installed. I
> believe, pulseaudio dependency may be safely removed.

The point is that vmware exploits pulseaudio when it finds the library but it doesn't fail without the library. A possibility might be the introduction of a conditional dep on the pulseaudio useflag, something similar was implemented also with cups dep but I prefer to avoid conditions (with -pulseaudio the user expects to disable pulseaudio support, if the package is installed later there is no way to disable it...). IMHO managing the deps for binary software is a mess and I don't want to test every possible combination ...
 
> By the way, I found another minor issue. Entering serial number doesn't work
> when USE=-bundled-libs with the following error:
> 
> I125: HandleLicenseOutput(stdErr): /opt/vmware/lib/vmware/bin/vmware-gksu:
> symbol lookup error:
> /opt/vmware/lib/vmware/lib/libvmware-gksu.so/libvmware-gksu.so: undefined
> symbol: gksu_context_set_on_fork
> 
> Bundled libgksu works as expected.

Thanks for the report. I'm using the only version available in portage which is 2.0.12-r2 and I confirm it doesn't have the gksu_context_set_on_fork symbol. So libgksu2.so.0 should not be removed, this lib requires also libgtop-2.0.so.7. I'll fix the repo later.

The more time I spend on this ebuild and the more I think we should remove completely the -bundled-libs feature. First reason is that with the time more and more libraries will not be available in portage (which means removing a lib from unbundling process). The second reason is that it's impossible to guarantee compatibility between a bundled and system library because we don't have full details about the versions of bundled libs, they might be even patched...

FYI, in this particular case it seems that the bundled libgksu.so is a patched version of libgksu-2.0.12 :-(
Comment 88 Billy DeVincentis 2016-03-17 00:42:22 UTC
Fabio,
I just updated my ebuilds from your overlay and I saw that you have included a message that gcc 5 requires bundled libs. My problem is that bundled libs leaves my vmware menu fonts incredibly small. On gcc 4 with -bundled-libs, fonts were correct. Do we know what bundled lib is responsible for the problem and simply remove that from the bundled and force the use of that system library?
Comment 89 Billy DeVincentis 2016-03-17 01:01:35 UTC
Created attachment 428398 [details]
screenshot of small fonts

Here is a picture, note how much larger the dolphin fonts are in the window behind vmware
Comment 90 Alexander Bezrukov 2016-03-18 22:17:26 UTC
(In reply to Fabio Rossi from comment #87)
> > I just tried to run it without pulseaudio installed. It uses pure ALSA then.
> > Sound works well at least in a Windows guest with vmware-tools installed. I
> > believe, pulseaudio dependency may be safely removed.
> 
> The point is that vmware exploits pulseaudio when it finds the library but
> it doesn't fail without the library. A possibility might be the introduction
> of a conditional dep on the pulseaudio useflag, something similar was
> implemented also with cups dep but I prefer to avoid conditions (with
> -pulseaudio the user expects to disable pulseaudio support, if the package
> is installed later there is no way to disable it...). IMHO managing the deps
> for binary software is a mess and I don't want to test every possible
> combination ...

Why not simply remove the dependency without any conditionals? If user wants to setup pulseaudio and did this, pulseaudio will be used. Otherwise plain ALSA will work out of the box. In any case, user has a choice to select what (s)he wants.

> The more time I spend on this ebuild and the more I think we should remove
> completely the -bundled-libs feature. First reason is that with the time
> more and more libraries will not be available in portage (which means
> removing a lib from unbundling process). The second reason is that it's
> impossible to guarantee compatibility between a bundled and system library
> because we don't have full details about the versions of bundled libs, they
> might be even patched...

Upcoming migration to --std=c++11 (or to >=gcc-5*) will make it necessary to install binary packages with bundled-libs only anyway because of ABI incompatibilities. I am not sure though if at the moment of the migration vmware-workstation will not become too old.
Comment 91 Andreas K. Hüttel gentoo-dev 2016-03-19 17:14:16 UTC
From 05f59490ec40787c0630d26995a8a08496f4363d Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Andreas=20K=2E=20H=C3=BCttel?= <dilfridge@gentoo.org>
Date: Sat, 19 Mar 2016 18:06:05 +0100
Subject: app-emulation/vmware-workstation: Major version bump. Imported from
 the vmware overlay.

Many thanks to
* Alex Xu <alex_y_xu@yahoo.ca>
* Billy DeVincentis <billydv1@verizon.net>
* Fabio Rossi <rossi.f@inwind.it>
* Evan Teran <evan.teran@gmail.com>
* Harris Landgarten <harrisl@lhjonline.com>
and to everyone else who helped on bug 559798.

-------------

Please file separate bugs for separate problems with the program / ebuild now; I'm closing this one. 

The ebuild is identical to Fabio's last version, the module patches are from Evan's vmware overlay commit. 

@Fabio: if you want to keep preparing patches and bumps, it might be easier to force-push your overlay to be identical to the vmware overlay master now, and then re-add patches... right now the merges are a bit messy....
Comment 92 Manfred Knick 2016-03-20 14:31:20 UTC
(In reply to Alexander Bezrukov from comment #90)

> Why not simply remove the dependency without any conditionals? If user wants
> to setup pulseaudio and did this, pulseaudio will be used. Otherwise plain
> ALSA will work out of the box. In any case, user has a choice to select what
> (s)he wants.

   +1:

At the time being, masking media-sound/pulseaudio in ../package.mask 
is not working because the ebuild requires it necessarily:

... The following mask changes are necessary to proceed: (...)
... # required by media-plugins/alsa-plugins-1.0.29::gentoo[pulseaudio]
... =media-sound/pulseaudio-8.0

Just removing the line from RDEPEND works as expected and proposed by Alex -
and reduces the amount of additional packages pulled in significantly.
Comment 93 Denis Klens 2016-03-20 15:10:02 UTC
> Just removing the line from RDEPEND works as expected and proposed by Alex -
> and reduces the amount of additional packages pulled in significantly.

I removed pulseaudio too and it works like a charm. Please remove this "bloatware" from the ebuild.
Comment 94 Andreas K. Hüttel gentoo-dev 2016-03-20 18:06:31 UTC
(In reply to Denis Klens from comment #93)
> > Just removing the line from RDEPEND works as expected and proposed by Alex -
> > and reduces the amount of additional packages pulled in significantly.
> 
> I removed pulseaudio too and it works like a charm. Please remove this
> "bloatware" from the ebuild.

Done in overlay and main tree